#!/bin/sh -x

OSC_PATH=isv:datadome:software
PKG=datadome-proxyserver
VERSION=1.2
RELEASE=$(git log --pretty=oneline | wc -l | sed -e 's:.* ::')

rm -rf osc_tree
osc checkout -o osc_tree $OSC_PATH $PKG  

./git-archive-all ./osc_tree/datadome-proxyserver.tar.gz

rm -f ./osc_tree/datadome-proxyserver.spec
sed -e s:%%VERSION%%:$VERSION:g -e s:%%RELEASE%%:$RELEASE:g datadome-proxyserver.spec.in > ./osc_tree/datadome-proxyserver.spec

rm -f ./osc_tree/datadome-proxyserver.dsc
sed -e s:%%VERSION%%:$VERSION:g -e s:%%RELEASE%%:$RELEASE:g datadome-proxyserver.dsc.in > ./osc_tree/datadome-proxyserver.dsc

rm -f ./osc_tree/datadome-proxyserver.init
cp ./datadome-proxyserver.init ./osc_tree/datadome-proxyserver.init

rm -f ./osc_tree/datadome-proxyserver.suse-init
cp ./datadome-proxyserver.suse-init ./osc_tree/datadome-proxyserver.suse-init

osc add osc_tree/datadome-proxyserver.tar.gz
osc add osc_tree/datadome-proxyserver.dsc
osc add osc_tree/datadome-proxyserver.spec
osc add osc_tree/datadome-proxyserver.init
osc add osc_tree/datadome-proxyserver.suse-init
osc ci -m 'Jenkins' osc_tree
